{{- if and .Values.ingress.jupyterlab.className (not (semverCompare ">=1.18-0" .Capabilities.KubeVersion.GitVersion)) }}
  {{- if not (hasKey .Values.ingress.jupyterlab.annotations "kubernetes.io/ingress.class") }}
  {{- $_ := set .Values.ingress.jupyterlab.annotations "kubernetes.io/ingress.class" .Values.ingress.jupyterlab.className}}
  {{- end }}
{{- end }}
{{- if semverCompare ">=1.19-0" .Capabilities.KubeVersion.GitVersion -}}
apiVersion: networking.k8s.io/v1
{{- else if semverCompare ">=1.14-0" .Capabilities.KubeVersion.GitVersion -}}
apiVersion: networking.k8s.io/v1beta1
{{- else -}}
apiVersion: extensions/v1beta1
{{- end }}
kind: Ingress
metadata:
  name: {{ .Release.Name }}-jupyterlab-ingress
  labels:
    tier: aihub-dag
    component: jupyterlab
    release: {{ .Release.Name }}
  {{- with .Values.ingress.jupyterlab.annotations }}
  annotations:
    {{- toYaml . | nindent 4 }}
  {{- end }}
spec:
  {{- if and .Values.ingress.jupyterlab.className (semverCompare ">=1.18-0" .Capabilities.KubeVersion.GitVersion) }}
  ingressClassName: {{ .Values.ingress.jupyterlab.className }}
  {{- end }}
  rules:
    {{- range .Values.ingress.jupyterlab.hosts }}
    - host: {{ .host | quote }}
      http:
        paths:
          {{- range .paths }}
          - path: {{ .path }}
            {{- if and .pathType (semverCompare ">=1.18-0" $.Capabilities.KubeVersion.GitVersion) }}
            pathType: {{ .pathType }}
            {{- end }}
            backend:
              {{- if semverCompare ">=1.19-0" $.Capabilities.KubeVersion.GitVersion }}
              service:
                name: {{ $.Release.Name }}-jupyterlab
                port:
                  name: jupyterlab-port
              {{- else }}
              serviceName: {{ $.Release.Name }}-jupyterlab
              servicePort: jupyterlab-port
              {{- end }}
          {{- end }}
    {{- end }}
